"use strict";
Object.defineProperty(exports, "__esModule", {
    value: true
});
function _export(target, all) {
    for(var name in all)Object.defineProperty(target, name, {
        enumerable: true,
        get: all[name]
    });
}
_export(exports, {
    collapsibleListUnion: ()=>collapsibleListUnion,
    listUnion: ()=>listUnion
});
const _domainsTs = require("../../utils/domains.js");
const _composeTs = require("../compose.js");
const collapsibleListUnion = (l, r)=>{
    if ((0, _domainsTs.hasSubdomain)(l, "Array")) {
        if ((0, _domainsTs.hasSubdomain)(r, "Array")) {
            const result = listUnion(l, r);
            return result.length === l.length ? result.length === r.length ? (0, _composeTs.equality)() : l : result.length === r.length ? r : result;
        }
        return l.includes(r) ? l : [
            ...l,
            r
        ];
    }
    if ((0, _domainsTs.hasSubdomain)(r, "Array")) {
        return r.includes(l) ? r : [
            ...r,
            l
        ];
    }
    return l === r ? (0, _composeTs.equality)() : [
        l,
        r
    ];
};
const listUnion = (l, r)=>{
    const result = [
        ...l
    ];
    for (const expression of r){
        if (!l.includes(expression)) {
            result.push(expression);
        }
    }
    return result;
};
