"use strict";
Object.defineProperty(exports, "__esModule", {
    value: true
});
function _export(target, all) {
    for(var name in all)Object.defineProperty(target, name, {
        enumerable: true,
        get: all[name]
    });
}
_export(exports, {
    parseDefinition: ()=>parseDefinition,
    as: ()=>as,
    unknownDefinitionMessage: ()=>unknownDefinitionMessage,
    writeBadDefinitionTypeMessage: ()=>writeBadDefinitionTypeMessage
});
const _mainTs = require("../main.js");
const _domainsTs = require("../utils/domains.js");
const _errorsTs = require("../utils/errors.js");
const _recordTs = require("./record.js");
const _stringTs = require("./string/string.js");
const _tupleTs = require("./tuple/tuple.js");
const parseDefinition = (def, ctx)=>{
    const subdomain = (0, _domainsTs.subdomainOf)(def);
    return subdomain === "string" ? (0, _stringTs.parseString)(def, ctx) : subdomain === "object" ? (0, _recordTs.parseRecord)(def, ctx) : subdomain === "Array" ? (0, _tupleTs.parseTuple)(def, ctx) : subdomain === "RegExp" ? {
        string: {
            regex: def.source
        }
    } : (0, _mainTs.isType)(def) ? def.node : (0, _errorsTs.throwParseError)(writeBadDefinitionTypeMessage(subdomain));
};
const as = Symbol("as");
const unknownDefinitionMessage = "Cannot statically parse a definition inferred as unknown. Consider using 'as inferred<...>' to cast it.";
const writeBadDefinitionTypeMessage = (actual)=>`Type definitions must be strings or objects (was ${actual})`;
