import { isType } from "../main.js";
import { subdomainOf } from "../utils/domains.js";
import { throwParseError } from "../utils/errors.js";
import { parseRecord } from "./record.js";
import { parseString } from "./string/string.js";
import { parseTuple } from "./tuple/tuple.js";
export const parseDefinition = (def, ctx)=>{
    const subdomain = subdomainOf(def);
    return subdomain === "string" ? parseString(def, ctx) : subdomain === "object" ? parseRecord(def, ctx) : subdomain === "Array" ? parseTuple(def, ctx) : subdomain === "RegExp" ? {
        string: {
            regex: def.source
        }
    } : isType(def) ? def.node : throwParseError(writeBadDefinitionTypeMessage(subdomain));
};
export const as = Symbol("as");
export const unknownDefinitionMessage = "Cannot statically parse a definition inferred as unknown. Consider using 'as inferred<...>' to cast it.";
export const writeBadDefinitionTypeMessage = (actual)=>`Type definitions must be strings or objects (was ${actual})`;
