import type { Subdomain } from "../../utils/domains.js";
import type { Dict } from "../../utils/generics.js";
import type { TraversalNode, TypeNode } from "../node.js";
import type { FlattenAndPushRule } from "./rules.js";
export type SubdomainRule<$ = Dict> = Subdomain | readonly ["Array", TypeNode<$>] | readonly ["Array", TypeNode<$>] | readonly ["Set", TypeNode<$>] | readonly ["Map", TypeNode<$>, TypeNode<$>];
export type TraversalSubdomainRule = Subdomain | readonly ["Array", TraversalNode] | readonly ["Array", TraversalNode] | readonly ["Set", TraversalNode] | readonly ["Map", TraversalNode, TraversalNode];
export declare const subdomainIntersection: import("../compose.js").Intersector<SubdomainRule<Dict> | undefined>;
export declare const subdomainPathSegments: {
    readonly "${number}": true;
    readonly "${item}": true;
    readonly "${key}": true;
    readonly "${value}": true;
};
export type SubdomainPathSegment = keyof typeof subdomainPathSegments;
export declare const flattenSubdomain: FlattenAndPushRule<SubdomainRule>;
